#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

#include "nodes.h"
#include "parser.h"
#include "table.h"

/*alloca e inizializza il campo info dell' elemento del dizionario degli ipertesti. Ritorna il puntatore alla struttura creata.*/
struct info_ipertesto *new_diz_loc(struct info_ipertesto *ii){
	ii = malloc(sizeof(struct info_ipertesto));
	assert(ii);
	ii->lista_in = NULL;
	ii->lista_out = NULL;
	ii->diz_loc = NULL;
	ii->page_rank = 0;
	return ii;
}

/*Cerca nel dizionario locale la parola str.
PRE:argomenti non nulli
POST: Ritorna il puntatore all' elemento del diz loc oppure NULL se non c'.*/
struct elem_diz_loc *search_diz_loc(char *str, struct info_ipertesto *ii){
	struct elem_diz_loc *pdl = ii->diz_loc;
	while(pdl!=NULL){
		if(!strcmp(str, pdl->parola))
			break;
		pdl = pdl->next_word;
	}
	return pdl;
}

/*aggiunge in testa alla lista del diz. loc. il nuovo elemento, riempie il campo parola e il campo next_word. 
PRE: argomenti non nulli.
POST:inizializza il campo hitlist a NUll e il campo dim a 0. Ritorna il puntatore al nuovo elemento.*/
struct elem_diz_loc *new_loc_entry(struct info_word *iw, struct info_ipertesto *ii){
	struct elem_diz_loc *pdl = ii->diz_loc;
	ii->diz_loc = malloc(sizeof(struct elem_diz_loc));
	assert(ii->diz_loc);
	ii->diz_loc->parola = calloc(strlen(iw->parola)+1, sizeof(char));
	assert(ii->diz_loc->parola);
	strcpy(ii->diz_loc->parola, iw->parola);
	ii->diz_loc->hitlist = NULL;
	ii->diz_loc->dim = 0;
	ii->diz_loc->next_word = pdl;
	return ii->diz_loc;
}

/*ritorna 1 se il link  da inserire nel grafo, 0 altrimenti.
	PRE: l'argomento curr non nullo*/
int is_new_link(struct info_word *last, struct info_word *curr){
	if(last==NULL)/*se  il primo da inserire*/
		return 1;
	if(curr->link_pos!=last->link_pos)/*se non sono nello stesso tag*/
		return 1;
	return 0;
}

/*torna il puntatore all' elemento ricercato name scorrendo la lista in input o NULL altrimenti
PRE: name != NULL*/
struct info_link *link_list_search(char *name, struct info_link *list){
	struct info_link *pil;
	for(pil=list; pil!=NULL; pil=pil->next){
		if(!strcmp(name, pil->ptr_pagina->key))
			return pil;
	}
	return NULL;
}

/*aggiorna il grafo dei link. 
	PRE: argomenti !NULL, se l'elemento  gi presente nella lista_out deve esserlo anche nella lista_in della pagina puntata.*/
void update_link_graph(struct tabelem *linked, struct tabelem *linking){
	struct info_link *il;
	struct info_ipertesto *linked_ii, *linking_ii;
	linked_ii = linked->info;
	linking_ii = linking->info;
	/*lista out*/
	il = link_list_search(linked->key, linking_ii->lista_out);
	if(il!=NULL){
		il->molteplicita++;
	}else{
		il = malloc(sizeof(struct info_link));
		assert(il);
		il->ptr_pagina = linked;
		il->molteplicita = 1;
		il->next = linking_ii->lista_out;
		linking_ii->lista_out = il;
	}
	/*lista in*/
	if(linked_ii==NULL)
		linked_ii = new_diz_loc(linked_ii);
	il = link_list_search(linking->key, linked_ii->lista_in);
	if(il!=NULL){
		il->molteplicita++;
	}else{
		il = malloc(sizeof(struct info_link));
		assert(il);
		il->ptr_pagina = linking;
		il->molteplicita = 1;
		il->next = linked_ii->lista_in;
		linked_ii->lista_in = il;
	}
}
/*void stampa_lista(struct tabelem *el){
	struct info_link *pls;
	struct info_ipertesto *ii = el->info;
	printf("listaout\n");
	for(pls=ii->lista_out; pls!=NULL; pls=pls->next)
		printf(" ls @ %d, ls->ptr_pagina = %s, molt = %d, ls->next @ %d\n",pls,pls->ptr_pagina->key,pls->molteplicita,pls->next);
	printf("listain\n");
	for(pls=ii->lista_in; pls!=NULL; pls=pls->next)
		printf(" ls @ %d, ls->ptr_pagina = %s, molt = %d, ls->next @ %d\n",pls,pls->ptr_pagina->key,pls->molteplicita,pls->next);
}

/*PRE: argomento !NULL, tutti i file ipertesto della dir di lavoro gi inseriti in tabella.
	POST: completa il dizionario degli ipertesti e crea i dizionari locali.*/
void create_diz_ipertesti(struct table *ptb){
	struct telist *pls;
	struct info_word *curr_wd;
	struct info_word *last_link;
	char *file_path;/*per memorizzare il percorso+nome completo del file*/
	FILE *curr_pg;
	struct elem_diz_loc *curr_loc_entry;
	struct elem_hitlist *hitlist_old_entry;
	struct tabelem *linked_pg;
	if(strcmp(main_path, ".")){
		if(main_path[strlen(main_path)-1]!='/')/*sistema il nome completo della dir, che deve terminare con '/'*/
				strcat(main_path, "/");
		file_path = calloc(strlen(main_path)+1, sizeof(char));
		assert(file_path);
	}
	for(pls=ptb->ls; pls!=NULL; pls=pls->next){/* per ogni ipertesto html....*/
		if(pls->el->info==NULL)/*se non  ancora stato creato il diz.loc.*/
			pls->el->info = new_diz_loc(pls->el->info);
		if(strcmp(main_path, ".")){
			strcpy(file_path, main_path);/*copia il nuovo nome completo del file dentro file_path*/
			strcat(file_path, pls->el->key);
			curr_pg = open_ipertesto(file_path);
		}else{
			curr_pg = open_ipertesto(pls->el->key);/*se la dir  "." basta il nome file*/
		}
		if(curr_pg==NULL) 
	    	printf("    ====> Impossibile aprire il file %s\n", file_path);
		for(curr_wd=next_word(curr_pg); curr_wd!=NULL; curr_wd=next_word(curr_pg)){/*per tutte le parole ...*/
			curr_loc_entry = search_diz_loc(curr_wd->parola, pls->el->info);
			if(curr_loc_entry==NULL)
				curr_loc_entry = new_loc_entry(curr_wd, pls->el->info);
			/*adesso aggiunge in testa alla hitlist il nuovo elemento.*/
			hitlist_old_entry = curr_loc_entry->hitlist;
			curr_loc_entry->hitlist = malloc(sizeof(struct elem_hitlist));
			curr_loc_entry->hitlist->info_occ_word = curr_wd;
			curr_loc_entry->hitlist->next_elem = hitlist_old_entry;
			curr_loc_entry->dim++;/*aggiorna il n. di occorrenze*/
			if(curr_wd->file_link!=NULL){/*se la parola letta  un link....*/
				linked_pg = table_search(ptb, curr_wd->file_link);
				if(linked_pg!=NULL){/*se la pagina linkata  nella dir di lavoro..*/
					if(is_new_link(last_link, curr_wd)){
						update_link_graph(linked_pg, pls->el);
						last_link = curr_wd;
					}
				}
			}
		}
		close_ipertesto(curr_pg);
		//stampa_lista(pls->el);
	}
}
