/* 
 * Laboratorio di Programmazione - A.A. 2004-05
 * Canali A-D (Nicola Galesi), P-Z (Stefano Guerini)
 * 
 * main1.h
 *
 * Main per la verifica del secondo modulo del progetto.
 */

#include <stdio.h>
#include <stdlib.h>

#include "table.h"
#include "parser.h"
#include "nodes.h"

char *main_path = NULL;


/* 
 * stampa un dizionario locale
 * PRE: ls e' la lista delle parola del dizionario locale
 */
void stampa_diz_locale(struct elem_diz_loc *ls) {
    struct elem_hitlist *hl;

    while (ls != NULL) {
	/* stampa la parola */
	printf("---- %s (%d)\n", ls->parola, ls->dim);
	for (hl = ls->hitlist; hl != NULL; hl = hl->next_elem) {
	    print_word(hl->info_occ_word);
	}
	ls = ls->next_word;
    }
}


/* 
 * stampa tutte le informazioni memorizzate
 * in un elemento della tavola (dati di un ipertesto)
 * PRE: el puntatore a un elemento della tavola
 */
void stampa_tabelem(struct tabelem *el){
    struct info_link *ls;
    struct info_ipertesto *iit = el->info;
    /* stampa la chiave (il nome del file) */
    printf("== \"%s\"\n", el->key);
    /* stampa out link */
    printf("-- out link\n");
    for (ls = iit->lista_in; ls != NULL; ls = ls->next) {
    printf("\"%s\" (%d)\n", ls->ptr_pagina->key, ls->molteplicita);
    }
    /* stampa in link */
    printf("-- in link\n");
    for (ls = iit->lista_out; ls != NULL; ls = ls->next) {
    printf("\"%s\" (%d)\n", ls->ptr_pagina->key, ls->molteplicita);
    }
    /* stampa dizionario locale */
    scanf("\n");
	printf("-- parole\n");
    stampa_diz_locale(iit->diz_loc);
}


int main(int argc, char *argv[]){
    struct table *node_tb;
    struct telist *ls;
    /* inizializza il nome della directory da leggere */
    if (--argc == 0) {
	main_path = "."; /* usa la dir corrente */
    } else {
	main_path = *++argv; /* dir letta dalla linea di comando */
    }
    printf("'Directory: %s'\n", main_path);
    /* crea la tavola dei file */
    node_tb = create_node_table(main_path);
    /* crea il dizionario */
    create_diz_ipertesti(node_tb);
    /* scandisci la lista dei file letti
     * e stampa le informazioni del grafo */
    for (ls = node_tb->ls; ls != NULL; ls = ls->next) {
	stampa_tabelem(ls->el);
    }
    return 0;
}
