/* 
 * Laboratorio di Programmazione - A.A. 2004-05
 * Canali A-D (Nicola Galesi), P-Z (Stefano Guerini)
 * 
 * parser.h
 */

#define MAX_TOKEN_LENGTH    256

#if !defined __PARSER_H

#define __PARSER_H 1

#include <stdio.h>
#include "nodes.h"

enum token_t {special, word};

struct token {
    enum token_t kind;
    union {
	char   ch;
        char   str[MAX_TOKEN_LENGTH];
    }                        u;
};

enum tag_t {unknown_tag, title_tag, body_tag,
	    small_tag, large_tag, a_tag, b_tag, i_tag
};

enum tag_kind {open, close};

struct info_tag {
    enum tag_t t;
    enum tag_kind k;
    char str[MAX_TOKEN_LENGTH];
};

typedef struct token        token;

int next_token(FILE *fp, token *ptk);
int next_quoted_word(FILE *fp, token *ptk);
FILE *open_ipertesto(char *fname);
void close_ipertesto(FILE *fp);

struct info_word *next_word(FILE *fp);

void print_tk(token *ptk);
void print_word(struct info_word *piw);

#endif
